import re

import pandas as pd

if __name__ == '__main__':
    df = pd.read_csv('petmd.csv')

    df_col = df.columns

    data_dict = {
        'Disease': [],
        'DiseaseDescription': [],
        'DiseaseCauseDescription': [],
        'DiseaseDiagnoseDescription': [],
        'DiseasePreventionDescription': [],
        'DiseaseSymptomDescription': [],
        'DiseaseTreatmentDescription': [],
        'DiseaseInfection': []
    }

    disease = ''
    diseases = []

    for index, row in df.iterrows():
        new_disease = row[df_col[0]]
        if disease != new_disease:
            disease = new_disease
            diseases.append(disease)

    for disease in diseases:
        grouped_rows = df[df[df_col[0]] == disease]

        regex = re.compile('[^a-zA-Z]')
        txt = str(disease).strip().replace(" ", "").replace("'", "").replace("inDogs", "")
        head, sep, tail = txt.partition(":")
        txt2 = head
        head, sep, tail = txt2.partition("(")
        txt3 = head
        head, sep, tail = txt3.partition("/")
        txt4 = regex.sub('', str(head))

        data_dict['Disease'].append(txt4)
        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'What|what')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseaseDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'Cause|cause')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseaseCauseDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseCauseDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'Diagnose|diagnose')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseaseDiagnoseDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseDiagnoseDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'Prevention|prevention')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseasePreventionDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseasePreventionDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'Symptoms|symptoms')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseaseSymptomDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseSymptomDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            regexp = re.compile(r'Treatment|treatment')
            topic = row[1][df_col[1]]
            description = row[1][df_col[2]]
            if regexp.search(str(topic)):
                data_dict['DiseaseTreatmentDescription'].append(str(description))
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseTreatmentDescription'].append('')

        temp = 0
        for row in grouped_rows.iterrows():
            description = row[1][df_col[2]]
            regexp = re.compile(r'Allerg|allerg')
            if regexp.search(str(description)):
                data_dict['DiseaseInfection'].append('Allergic')
                temp = 1
                break

            regexp = re.compile(r'Bacter|bacter')
            if regexp.search(str(description)):
                data_dict['DiseaseInfection'].append('Bacterial')
                temp = 1
                break

            regexp = re.compile(r'Flea|flea')
            if regexp.search(str(description)):
                data_dict['DiseaseInfection'].append('Fleas')
                temp = 1
                break

            regexp = re.compile(r'Fung|fung')
            if regexp.search(str(description)):
                data_dict['DiseaseInfection'].append('Fungal')
                temp = 1
                break

            regexp = re.compile(r'Virus|virus')
            if regexp.search(str(description)):
                data_dict['DiseaseInfection'].append('Viral')
                temp = 1
                break

        if temp == 0:
            data_dict['DiseaseInfection'].append('')

    pd.DataFrame(data_dict).drop_duplicates().to_csv('dogDisease.csv', index=False)
